/**
 * 
 */
package net.moioli.chart;

/**
 * @author silvio
 *
 */
public interface ChartI {

    /**
     * Draws this DefaultChart on the passed GraphicsI surface.
     * 
     * @param g
     *            the surface where this DefaultChart will be drawn
     * @param clip
     *            the clipping rectangle to be used for drawing
     */
    void drawMe(GraphicsI g, IntRectangle clip);

    // Getters and Setters
    /**
     * Returns the maximum x value represented.
     * 
     * @return Returns the maximum x value represented.
     */
    double getMaxX();

    /**
     * Returns the maximum x value represented.
     * 
     * @param maxX
     *            The maximum x value represented.
     */
    void setMaxX(double maxX);

    /**
     * Returns the minimum x value represented.
     * 
     * @return Returns the minimum x value represented.
     */
    double getMinX();

    /**
     * The minimum x value to be represented.
     * 
     * @param minX
     *            The minimum x value represented.
     */
    void setMinX(double minX);

    /**
     * Returns the maximum y value represented.
     * 
     * @return Returns the maximum y value represented.
     */
    double getMaxY();

    /**
     * The maximum y value to be represented.
     * 
     * @param maxY
     *            The maximum y value represented.
     */
    void setMaxY(double maxY);

    /**
     * Returns the minimum y value represented.
     * 
     * @return Returns the minimum y value represented.
     */
    double getMinY();

    /**
     * The minimum y value represented.
     * 
     * @param minY
     *            The minimum y value represented.
     */
    void setMinY(double minY);

    /**
     * Returns the pixelAccuracy value. To draw mathematical functions, DefaultChart
     * will calculate the value of the function multiple times. This parameter
     * assigns the the number of pixels on the x axis after which the y value
     * will be recalculated. 1 is the minimum possible value (maximum
     * precision), 3 is recommended in most cases.
     * 
     * @return pixelAccuracy
     */
    int getPixelAccuracy();

    /**
     * The pixelAccuracy to set. To draw mathematical functions, DefaultChart will
     * calculate the value of the function multiple times. This parameter
     * assigns the the number of pixels on the x axis after which the y value
     * will be recalculated. 1 is the minimum possible value (maximum
     * precision), 3 is recommended in most cases.
     * 
     * @param pixelAccuracy
     */
    void setPixelAccuracy(int pixelAccuracy);

    // Overrides from Collection
    /**
     * @see java.util.Collection#add(Object arg0)
     */
    boolean add(Object arg0);

}